/***************************************************************
   3DMapping(Ported from EX-SYSTEM)
   24bit Color Modified for layman
   $Id: 3DMap.c,v 1.4 1998/10/24 13:02:29 TANE Exp $
***************************************************************/

#include	"common.h"
#include	"funcs.h"
#include	"3DMap.h"
#include	<math.h>

#ifndef	PI
#define	PI	3.1415926535898
#endif

int	TextureMap( int x1, int y1, int x2, int y2,
	            struct VGRAM_STRUCT *vg_pt , struct Mapping_Vector *map_pt
)
{
int	x, y, x00, x01, y00, y01, x10, x11, y10, y11;
unsigned int	r0, g0, b0, r1, g1, b1 ;
short	width,height ;
unsigned int	r, g, b;

	width  = vg_pt->width ;
	height = vg_pt->height ;

	if( x1<0 ) x1 = 0; else if( x1>=width*16 ){
		return( -1 );
	}
	if( y1<0 ) y1 = 0; else if( y1>=height*16 ){
		return( -1 );
	}
	if( x2<0 ) return( -1 ); else if( x2>=width *16 ) x2 = width*16 -1;
	if( y2<0 ) return( -1 ); else if( y2>=height*16 ) y2 = height*16-1;
	x00 = x1>>4;
	x01 = 16-(x1%16);
	y00 = y1>>4;
	y01 = 16-(y1%16);
	x10 = x2>>4;
	x11 = (x2%16)+1;
	y10 = y2>>4;
	y11 = (y2%16)+1;
	r = g = b = 0 ;
	for( y=y00; y<=y10; y++ ){
		r1 = g1 = b1 = 0;
		for( x=x00; x<=x10; x++ ){
			b0 = vg_pt->pix[x+y*width].b ;
			r0 = vg_pt->pix[x+y*width].r ;
			g0 = vg_pt->pix[x+y*width].g ;
			if( x00==x10 ){
				b0 *= x11-(16-x01);
				r0 *= x11-(16-x01);
				g0 *= x11-(16-x01);
			} else if( x==x00 ){
				b0 *= x01;
				r0 *= x01;
				g0 *= x01;
			} else if( x==x10 ){
				b0 *= x11;
				r0 *= x11;
				g0 *= x11;
			} else {
				b0 <<= 4;
				r0 <<= 4;
				g0 <<= 4;
			}
			b1 += b0;
			r1 += r0;
			g1 += g0;
		}
		if( y00==y10 ){
			b1 *= y11-(16-y01);
			r1 *= y11-(16-y01);
			g1 *= y11-(16-y01);
		} else if( y==y00 ){
			b1 *= y01;
			r1 *= y01;
			g1 *= y01;
		} else if( y==y10 ){
			b1 *= y11;
			r1 *= y11;
			g1 *= y11;
		} else {
			b1 <<= 4;
			r1 <<= 4;
			g1 <<= 4;
		}
		b += b1;
		r += r1;
		g += g1;
	}
	x = x2-x1+1;
	y = y2-y1+1;
	map_pt->b = ((b+x/2)/x+y/2)/y;
	map_pt->r = ((r+x/2)/x+y/2)/y;
	map_pt->g = ((g+x/2)/x+y/2)/y;

	return( 0 );
}

int	BumpMap( int x1, int y1, int x2, int y2, int facex, int facey,
			 struct VGRAM_STRUCT *vg_pt, struct Mapping_Vector *map_pt )
{
int	x, y, x00, x01, y00, y01, x10, x11, y10, y11;
int	u0, v0, u1, v1, m0, m1, r1, g1, b1, r2, g2, b2;
double	u, v, w, r0, rx, ry;
short	width,height ;
double	vx, vy, vz;
int		level ;

	vx   = map_pt->vx ;
	vy   = map_pt->vy ;
	vz   = map_pt->vz ;
	level= map_pt->bumplevel ;

	width  = vg_pt->width ;
	height = vg_pt->height ;

	if( x1<0 ) x1 = 0; else if( x1>=width*16  ) return( -1 );
	if( y1<0 ) y1 = 0; else if( y1>=height*16 ) return( -1 );
	if( x2<0 ) return( -1 ); else if( x2>=width*16  ) x2 = width*16-1;
	if( y2<0 ) return( -1 ); else if( y2>=height*16 ) y2 = height*16-1;
	x00 = x1>>4;
	x01 = 16-(x1%16);
	y00 = y1>>4;
	y01 = 16-(y1%16);
	x10 = x2>>4;
	x11 = (x2%16)+1;
	y10 = y2>>4;
	y11 = (y2%16)+1;
	u = v = 0.0;
//	m = 0;
	m0 = VALUE_MAX+1 ;
	for( y=y00; y<=y10; y++ ){
		u1 = v1 = m1 = 0;
		for( x=x00; x<=x10; x++ ){
			g2 = vg_pt->pix[x+y*width].g ;
			r2 = vg_pt->pix[x+y*width].r ;
			b2 = vg_pt->pix[x+y*width].b ;
			if( x>0 ){
				g1 = vg_pt->pix[(x-1)+y*width].g ;
				r1 = vg_pt->pix[(x-1)+y*width].r ;
				b1 = vg_pt->pix[(x-1)+y*width].b ;
				u0 = g1+r1+b1-g2-r2-b2;
			} else u0 = 0;
			if( y>0 ){
				g1 = vg_pt->pix[x+(y-1)*width].g ;
				r1 = vg_pt->pix[x+(y-1)*width].r ;
				b1 = vg_pt->pix[x+(y-1)*width].b ;
				v0 = g1+r1+b1-g2-r2-b2;
			} else v0 = 0;
			if( x00==x10 ){
				u0 *= x11-(16-x01);
				v0 *= x11-(16-x01);
				m0 *= x11-(16-x01);
			} else if( x==x00 ){
				u0 *= x01;
				v0 *= x01;
				m0 *= x01;
			} else if( x==x10 ){
				u0 *= x11;
				v0 *= x11;
				m0 *= x11;
			} else {
				u0 <<= 4;
				v0 <<= 4;
				m0 <<= 4;
			}
			u1 += u0;
			v1 += v0;
			m1 += m0;
		}
		if( y00==y10 ){
			u1 *= y11-(16-y01);
			v1 *= y11-(16-y01);
			m1 *= y11-(16-y01);
		} else if( y==y00 ){
			u1 *= y01;
			v1 *= y01;
			m1 *= y01;
		} else if( y==y10 ){
			u1 *= y11;
			v1 *= y11;
			m1 *= y11;
		} else {
			u1 <<= 4;
			v1 <<= 4;
			m1 <<= 4;
		}
		u += (double)u1;
		v += (double)v1;
//		m += m1;
	}
	if( facex ) v = -v;
	if( facey ) u = -u;
	x = x2-x1+1;
	y = y2-y1+1;
	r0 = sqrt( vx*vx+vy*vy+vz*vz );
	u *= r0/(double)x/(double)y/(double)(8-level*2);
	v *= r0/(double)x/(double)y/(double)(8-level*2);
//	m = ((m+x/2)/x+y/2)/y;
	/* @xNg@񂺂񐳊mȂ */
	rx = sqrt( vz*vz+vx*vx );
	ry = sqrt( vz*vz+vy*vy );
	w = vz;
	if( rx>0 ) w -= u*vx/rx; else w -= u;
	if( ry>0 ) w -= v*vy/ry; else w -= v;
	if( w>0 ){
		if( rx>0 ) vx += u*vz/rx; else vx += u;
		if( ry>0 ) vy += v*vz/ry; else vy += v;
		vz = w;
	}
	map_pt->vx = vx ;
	map_pt->vy = vy ;
	map_pt->vz = vz ;
	return( 0 );
}

void	Shade( int x1, int y1, int shadow_mode , int hilight_mode,
               struct Mapping_Vector *map_pt )
{
	double	l, h, sina, cosa, sinb, cosb, xx, yy, zz;
	double	vx1, vy1, vz1;
	double	vx0, vy0, vz0, l0, ll;
	double	hl, hk;
	double	vx, vy, vz;
	unsigned int	r, g, b;

	vx0 = map_pt->vx0 ;
	vy0 = map_pt->vy0 ;
	vz0 = map_pt->vz0 ;
	l0  = map_pt->l0 ;
	ll  = map_pt->ll ;
	hl  = map_pt->hl ;
	hk  = map_pt->hk ;
	vx  = map_pt->vx ;
	vy  = map_pt->vy ;
	vz  = map_pt->vz ;
	r   = map_pt->r ;
	g   = map_pt->g ;
	b   = map_pt->b ;

	/* Aex */
	l = ll*(vx0*vx+vy0*vy+vz0*vz)/sqrt( (vx0*vx0+vy0*vy0+vz0*vz0)*(vx*vx+vy*vy+vz*vz) );
	/*  */
	if( l>0 ) l += l0; else l = l0;
	if( l>(double)1.0 ) l = (double)1.0;
	/* ˌxNg */
	/* IWił vx  0 \Aۂ̃P[Xatan()̖߂l */
	/* sƂȂĂ̂ŏC */
	if( vx==0.0 ){
		sina = (double)PI/2.0 ;
		if( vy>=0.0 ) sina = -sina ;
	}else {
		sina = atan( -vy/vx );
		if( vx<0.0 ) sina += (double)PI;
	}
	cosa = cos( sina );
	sina = sin( sina );
	sinb = atan( vz/sqrt(vx*vx+vy*vy) );
	cosb = cos( sinb );
	sinb = sin( sinb );
	xx = vx0*cosa-vy0*sina;
	yy = vx0*sina+vy0*cosa;
	zz = -xx*sinb+vz0*cosb;
	xx = xx*cosb+vz0*sinb;
	yy = -yy;
	zz = -zz;
	vx1 = xx*cosb-zz*sinb;
	vz1 = xx*sinb+zz*cosb;
	vy1 = -vx1*sina+yy*cosa;
	vx1 = vx1*cosa+yy*sina;

	/* nCCg */
	if( vz1>0.0 && hilight_mode == ON ){
		h = sqrt( vx1*vx1+vy1*vy1 )/vz1;
		h = hl/(hk*h*h+1.0) * VALUE_MAX ;
	} else h = 0.0;

	if( shadow_mode == SHADOW_REVERSE ){
		g = (int)(VALUE_MAX-(double)(VALUE_MAX - g)*l+h) ;
		r = (int)(VALUE_MAX-(double)(VALUE_MAX - r)*l+h) ;
		b = (int)(VALUE_MAX-(double)(VALUE_MAX - b)*l+h) ;
	}else{
		g = (int)((double)(g)*l+h) ;
		r = (int)((double)(r)*l+h) ;
		b = (int)((double)(b)*l+h) ;
	}
	if( g>VALUE_MAX ) g = VALUE_MAX;
	if( r>VALUE_MAX ) r = VALUE_MAX;
	if( b>VALUE_MAX ) b = VALUE_MAX;

	map_pt->r = r ;
	map_pt->g = g ;
	map_pt->b = b ;

}

