/****************************************************************
 *	EX-Window Ver.2.0 X file.
 *	(c) i.kikuchi & i.yoshida
 *
  24bit Color modified for layman
  $Id: cone.c,v 1.6 1999/05/31 15:43:11 TANE Exp $
*****************************************************************/

#include	"common.h"
#include	"funcs.h"
#include	"cone.h"
#include	"3DMap.h"
#include	<math.h>

#ifndef	PI
#define	PI	3.1415926535898
#endif

#include	"Equation.h"

int		cone_lightset( char* , struct Mapping_Vector * );
int		Cone_main( struct VGRAM_STRUCT * , struct Mapping_Vector * );
int		cone_load( char* , struct Mapping_Vector * );


static	struct {
	int	type;
	char	str[36];
	int	para[2];
} ctrl[] = {
	{ 8,	"ʌa",	 	{	-3, 0 }, },	/* ID  0 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID  1 */
	{ 8,	"",		 	{	-3, 0 }, },	/* ID  2 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID  3 */
	{ 8,	"Vʍi",	 	{	-3, 0 }, },	/* ID  4 */
	{ 3,	"",			 	{65534, 0 }, },	/* ID  5 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID  6 */
	{ 8,	"~X",	 	{	-3, 0 }, },	/* ID  7 */
	{ 3,	"",			 	{65534, 0 }, },	/* ID  8 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID  9 */
	{ 8,	"~]",	 	{	-3, 0 }, },	/* ID 10 */
	{ 3,	"",			 	{65534, 0 }, },	/* ID 11 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID 12 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 13 */
	{ 8,	"Shading",	 	{	-3, 0 }, },	/* ID 14 */
	{ 2,	"ײèݸސݒ",	{	 1, 0 }, },	/* ID 15 */
	{ 5,	"",			 	{	 0, 0 }, },	/* ID 16 */
	{ 8,	"Mapping",	 	{	-3, 0 }, },	/* ID 17 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 18 */
	{ 8,	"Texture",	 	{	-3, 0 }, },	/* ID 19 */
	{ 5,	"",			 	{	 0, 0 }, },	/* ID 20 */
	{ 8,	"Bump",		 	{	-3, 0 }, },	/* ID 21 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 22 */
	{ 8,	"Forward",	 	{	-3, 0 }, },	/* ID 23 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 24 */
	{ 8,	"Back",		 	{	-3, 0 }, },	/* ID 25 */
	{ 6,	"",			 	{	 1, 1 }, },	/* ID 26 */
	{ 2,	"s",		 	{	 1, 0 }, },	/* ID 27 */
	{ 8,	"yʒu",	 	{	-3, 0 }, },	/* ID 28 */
	{ 3,	"",			 	{65534, 0 }, },	/* ID 29 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID 30 */
	{ 2,	"File",		 	{	 1, 0 }, },	/* ID 31 */
	{ 2,	"2",		 	{	 1, 0 }, }	/* ID 32 */
};

typedef enum CtrlNo {
	CtrlLB_BOTR,
	CtrlTB_BOTR,
	CtrlLB_HEIGHT,
	CtrlTB_HEIGHT,
	CtrlLB_TOPA,
	CtrlHS_TOPA,
	CtrlTB_TOPA,
	CtrlLB_PITCH,
	CtrlHS_PITCH,
	CtrlTB_PITCH,
	CtrlLB_BANK,
	CtrlHS_BANK,
	CtrlTB_BANK,
	CtrlCB_SHADE,
	CtrlLB_SHADE,
	CtrlBT_LIGHTSET,
	CtrlCB_MAP,
	CtrlLB_MAP,
	CtrlCB_TEXTURE,
	CtrlLB_TEXTURE,
	CtrlCB_BUMP,
	CtrlLB_BUMP,
	CtrlCB_FORWARD,
	CtrlLB_FORWARD,
	CtrlCB_BACK,
	CtrlLB_BACK,
	CtrlCC_SAMPLE,
	CtrlBT_EXEC,
	CtrlLB_ZPOS,
	CtrlHS_ZPOS,
	CtrlTB_ZPOS,
	CtrlBT_FILE,
	CtrlBT_BUMPLEVEL,
} CtrlNo;

int		shadow_mode , hilight_mode , draw_mode , ovlap_mode ;

/**********************************************************************
  Cone lݒ
***********************************************************************/
int	cone( struct VGRAM_STRUCT *vg_pt , struct CONE_EXEC_STRUCT *exec_info )
{
struct	Mapping_Vector map_dt , *map_pt ;

	map_pt = &map_dt ;
	if( exec_info->rend_file[0] != '\0' ){
		if( cone_load( exec_info->rend_file , map_pt ) != NORMAL_EXIT ){
			fprintf( stderr,"t@C %s I[vł܂łBftHglgp܂B\n",exec_info->rend_file ) ;
		}
	}
	if( exec_info->light_file[0] != '\0' ){
		if( cone_lightset( exec_info->light_file , map_pt ) != NORMAL_EXIT ){
			fprintf( stderr,"t@C %s I[vł܂łBftHglgp܂B\n",exec_info->light_file ) ;
		}
	}

	map_pt->sx0 = exec_info->sx ;
	map_pt->sy0 = exec_info->sy ;
	map_pt->ex0 = exec_info->ex ;
	map_pt->ey0 = exec_info->ey ;
	map_pt->org_r = exec_info->r ;
	map_pt->org_g = exec_info->g ;
	map_pt->org_b = exec_info->b ;

	shadow_mode = exec_info->shadow_mode ;
	hilight_mode = exec_info->hilight_mode ;
	draw_mode  = exec_info->draw_mode ;
	ovlap_mode = exec_info->ovlap_mode ;

	if( draw_mode == MAPPING ) ctrl[CtrlCB_MAP].para[0] = 1 ;
	if( draw_mode == NO_MAPPING ) ctrl[CtrlCB_MAP].para[0] = 0 ;
	if( exec_info->shade_mode == OFF ) ctrl[CtrlCB_SHADE].para[0] = 0 ;

	Cone_main( vg_pt , map_pt ) ;

	return( NORMAL_EXIT );
}

/**********************************************************************
  Cone _O{
***********************************************************************/
int	Cone_main( struct VGRAM_STRUCT *vg_pt , struct Mapping_Vector *map_pt )
{
int		x, y, ox1, oy1, ox2, oy2, x1, y1;
int		dx0, dy0, sx, ex, ty, by;
double	x00, y00, x01, y01, x02, y02, xx, yy, zz, rx, cx0, sinth, costh, tanth;
double	k1, k2, k, sinrth, cosrth;
int		i, j, result, facex, facey, tmp, thr;
double	a0[3], ans0[2], ans[2];

int		cx, cy, dx, dy, zpos;
int		sx0, sy0, ex0, ey0;
double	vx0, vy0, vz0, l0, ll;
double	hl, hk, a;
int		lcx, lcy, lcz, conelight;
int		th, rth, bumplevel;
double	vx, vy, vz;
unsigned int	org_r, org_g, org_b ;

int		width,height ;
struct	VGRAM_STRUCT vg_tmp , *vg_tmp_pt ;
int		exec_status ;

	vg_tmp_pt = &vg_tmp ;
	vg_alloc( vg_tmp_pt , vg_pt->width , vg_pt->height ) ;
	if( vg_tmp_pt->pix == NULL ){
		fprintf(stderr,"Ɨ̈̊mۂɎs܂\n") ;
		return( VGRAM_WORK_ALLOC_ERROR ) ;
	}
	if( ovlap_mode == OFF ){
		vg_clr( vg_tmp_pt , 0,0,0, VALUE_MAX ) ;
	}else{
		vg_cpy( vg_tmp_pt , vg_pt ) ;
	}

	cx = map_pt->cx ;
	cy = map_pt->cy ;
	zpos = map_pt->zpos ;
	sx0 = map_pt->sx0 ;
	sy0 = map_pt->sy0 ;
	ex0 = map_pt->ex0 ;
	ey0 = map_pt->ey0 ;
	vx0 = map_pt->vx0 ;
	vy0 = map_pt->vy0 ;
	vz0 = map_pt->vz0 ;
	l0 = map_pt->l0 ;
	ll = map_pt->ll ;
	hl = map_pt->hl ;
	hk = map_pt->hk ;
	lcx = map_pt->lcx ;
	lcy = map_pt->lcy ;
	lcz = map_pt->lcz ;
	dx =  map_pt->dx ;
	dy =  map_pt->dy ;
	a  =  map_pt->a ;
	conelight = map_pt->conelight ;
	th = map_pt->th ;
	rth = map_pt->rth ;
	bumplevel = map_pt->bumplevel ;
	vx = map_pt->vx ;
	vy = map_pt->vy ;
	vz = map_pt->vz ;
	org_r = map_pt->org_r ;
	org_g = map_pt->org_g ;
	org_b = map_pt->org_b ;

	width  = vg_pt->width ;
	height = vg_pt->height ;

	result = 0 ;

	if( conelight ){
		vx0 = (lcx-cx)?(lcx-cx):0.0;
		vy0 = (lcy-cy)?(lcy-cy):0.0;
		vz0 = (zpos-lcz)?(zpos-lcz):0.0;
		if( vx0==0.0 && vy0==0.0 && vz0==0.0 ) vz0 = 1.0;
	}
	rx = (double)dx/2.0;
	cx0 = (ex0+sx0)*8.0;
	if( th==90 ) k = 89.999; else if( th==-90 ) k = -89.999; else k = (double)th;
	sinth = sin( (double)PI*k/180.0 );
	costh = cos( (double)PI*k/180.0 );
	tanth = tan( (double)PI*k/180.0 );
	sinrth = sin( (double)PI*rth/180.0 );
	cosrth = cos( (double)PI*rth/180.0 );
	dx0 = ex0-sx0;
	dy0 = ey0-sy0;
	k2 = (1.0-a)*(double)dx/2.0/(double)dy*tanth;
	ty = by = 0;
	if( th>0 ){
		if( ctrl[CtrlCB_FORWARD].para[0] )	/* Forward */
			by = (int)((double)dx/2.0*sinth)+2;
		if( ctrl[CtrlCB_BACK].para[0] )	/* Back */
			ty = (int)(a*(double)dx/2.0*sinth)+2;
	} else {
		if( ctrl[CtrlCB_FORWARD].para[0] )	/* Forward */
			ty = -(int)(a*(double)dx/2.0*sinth)+2;
		if( ctrl[CtrlCB_BACK].para[0] )	/* Back */
			by = -(int)((double)dx/2.0*sinth)+2;
	}
	if( ty<by-dy*costh ) ty = by-dy*costh;
	by += dy*costh;
	ty = -ty-(double)dy/2.0*costh;
	by -= (double)dy/2.0*costh;
	k = dx/2.0+1;
	ans[0] = k*cosrth-ty*sinrth;
	ans[1] = -k*cosrth-ty*sinrth;
	ans[2] = k*cosrth-by*sinrth;
	ans[3] = -k*cosrth-by*sinrth;
	qsort( ans, 4, sizeof(double), compare );
	sx = ans[3];
	ex = ans[0];
	ans[0] = ty*cosrth+k*sinrth;
	ans[1] = by*cosrth+k*sinrth;
	ans[2] = ty*cosrth-k*sinrth;
	ans[3] = by*cosrth-k*sinrth;
	qsort( ans, 4, sizeof(double), compare );
	ty = ans[3];
	by = ans[0];

	for( y=ty; y<=by; y++ ){
		y1 = cy+y;
		if( y1<0 || y1>=height ) continue;
		for( x=sx; x<=ex; x++ ){
			x1 = cx+x;
			if( x1<0 || x1>=width ) continue;
			x00 = (double)x*cosrth+(double)y*sinrth;
			y00 = (double)y*cosrth-(double)x*sinrth+(double)dy/2.0*costh;
			x01 = x00-0.5;
			y01 = y00-0.5;
			x02 = x00+0.5;
			y02 = y00+0.5;

			k1 = y00*(1.0-a)*(double)dx/2.0/(double)dy/costh+a*(double)dx/2.0;
			a0[0] = 1-k2*k2;
			a0[1] = 2*k1*k2;
			a0[2] = x00*x00-k1*k1;
			j = Qadrti( a0, ans0 );
			if( j==0 ) continue;
			thr = 0;
			for( i=0; i<j; i++ ){
				zz = ans0[i];
				xx = x00;
				yy = y00/costh-zz*tanth;
				if( yy<0.0 || yy>dy ) continue;
				if( zz>=0.0 ){	/* Forward */
					if( !ctrl[CtrlCB_FORWARD].para[0] ) continue;
					facex = facey = 0;
				} else {	/* Back */
					if( !ctrl[CtrlCB_BACK].para[0] ) continue;
					facex = facey = 1;
				}
				vx = xx;
				vy = (a-1.0)*(double)dx/(double)dy/2.0*sqrt( xx*xx+zz*zz );
				vz = zz*costh-vy*sinth;
				vy = vy*costh+zz*sinth;
				k = vx*cosrth-vy*sinrth;
				vy = vy*cosrth+vx*sinrth;
				vx = k;
				if( vz<0.0 ){
					vx = -vx; vy = -vy; vz = -vz;
					facey ^= 1;
				}

				map_pt->vx0 = vx0 ;
				map_pt->vy0 = vy0 ;
				map_pt->vz0 = vz0 ;
				map_pt->l0 = l0 ;
				map_pt->ll = ll ;
				map_pt->hl = hl ;
				map_pt->hk = hk ;
				map_pt->vx = vx ;
				map_pt->vy = vy ;
				map_pt->vz = vz ;
				map_pt->bumplevel = bumplevel ;

				if( ctrl[CtrlCB_MAP].para[0] ){
					k1 = y01*(1.0-a)*(double)dx/2.0/(double)dy/costh+a*(double)dx/2.0;
					a0[0] = k2*k2-1;
					a0[1] = -2*k1*k2;
					a0[2] = k1*k1-x01*x01;
					if( j==Qadrti( a0, ans ) ) zz = ans[i]; else zz = ans0[i];
					xx = x01;
					yy = y01/costh-zz*tanth;
					ox1 = (int)((double)dx0*asin(xx/sqrt(xx*xx+zz*zz))/(double)PI*16.0+cx0);
					oy1 = (int)((yy*(double)dy0/(double)dy+sy0)*16.0);

					k1 = y02*(1.0-a)*(double)dx/2.0/(double)dy/costh+a*(double)dx/2.0;
					a0[0] = k2*k2-1;
					a0[1] = -2*k1*k2;
					a0[2] = k1*k1-x02*x02;
					if( j==Qadrti( a0, ans ) ) zz = ans[i]; else zz = ans0[i];
					xx = x02;
					yy = y02/costh-zz*tanth;
					ox2 = (int)((double)dx0*asin(xx/sqrt(xx*xx+zz*zz))/(double)PI*16.0+cx0);
					oy2 = (int)((yy*(double)dy0/(double)dy+sy0)*16.0);
					if( facex ){ ox1 = cx0*2-ox1; ox2 = cx0*2-ox2; }

					if( ox1>ox2 ){ tmp = ox1; ox1 = ox2; ox2 = tmp; }
					if( oy1>oy2 ){ tmp = oy1; oy1 = oy2; oy2 = tmp; }

					if( ctrl[CtrlCB_TEXTURE].para[0] )	/* Texture */
					result = TextureMap( ox1, oy1, ox2, oy2, vg_pt, map_pt );
					if( ctrl[CtrlCB_BUMP].para[0] )		/* Bump */
					result = BumpMap( ox1, oy1, ox2, oy2, facex, facey, vg_pt, map_pt );
				} else {
					if( draw_mode == LIGHTING_ONLY ){
						map_pt->r = vg_pt->pix[x1+y1*width].r ;
						map_pt->g = vg_pt->pix[x1+y1*width].g ;
						map_pt->b = vg_pt->pix[x1+y1*width].b ;
					}else{
						map_pt->r = org_r ;
						map_pt->g = org_g ;
						map_pt->b = org_b ;
					}
					result=0;
				}
				if( result==0 ){
					if( ctrl[CtrlCB_SHADE].para[0] ) Shade( x1, y1 , shadow_mode, hilight_mode, map_pt ) ;
					vg_tmp_pt->pix[x1+y1*width].r = map_pt->r ;
					vg_tmp_pt->pix[x1+y1*width].g = map_pt->g ;
					vg_tmp_pt->pix[x1+y1*width].b = map_pt->b ;
					if( ovlap_mode == OFF )	vg_tmp_pt->pix[x1+y1*width].a = 0 ;
					break ;
				}
			}
		}
	}
	vg_cpy( vg_pt , vg_tmp_pt ) ;
	exec_status = vg_free( vg_tmp_pt ) ;
	return( NORMAL_EXIT ) ;
}


/**********************************************************************
  Cone _O`ǂݍ
***********************************************************************/
int	cone_load( char *filename , struct Mapping_Vector *map_pt )
{
#include	"ConeItem.h"
	FILE	*fp;
	char	s[20];
	int	i;

	fp = fopen( filename, "rt" );
	if( fp==NULL ) return( FILE_OPEN_ERROR );

	do {
		fscanf( fp, "%s = ", s );
		for( i=0; i<ConeItemNum; i++ ){
			if( stricmp( s, ConeItem[i] )==0 ){
				switch( i ){
				case 0:	fscanf( fp, "%d\n", &(map_pt->cx) );
					break;
				case 1:	fscanf( fp, "%d\n", &(map_pt->cy) );
					break;
				case 2:	fscanf( fp, "%d\n", &(map_pt->dx) );
					break;
				case 3:	fscanf( fp, "%d\n", &(map_pt->dy) );
					break;
				case 4:	fscanf( fp, "%lf\n", &(map_pt->a) );
					break;
				case 5:	fscanf( fp, "%d\n", &(map_pt->th) );
					break;
				case 6:	fscanf( fp, "%d\n", &(map_pt->rth) );
					break;
				case 7:	fscanf( fp, "%d\n", &(map_pt->zpos) );
					break;
				case 8:	fscanf( fp, "%d\n", &ctrl[CtrlCB_SHADE].para[0] );
					break;
				case 9:	fscanf( fp, "%d\n", &ctrl[CtrlCB_MAP].para[0] );
					break;
				case 10:fscanf( fp, "%d\n", &ctrl[CtrlCB_TEXTURE].para[0] );
					break;
				case 11:fscanf( fp, "%d\n", &ctrl[CtrlCB_BUMP].para[0] );
					break;
				case 12:fscanf( fp, "%d\n", &(map_pt->bumplevel) );
					break;
				case 13:fscanf( fp, "%d\n", &ctrl[CtrlCB_FORWARD].para[0] );
					break;
				case 14:fscanf( fp, "%d\n", &ctrl[CtrlCB_BACK].para[0] );
					break;
				}
				break;
			}
		}
	} while( !feof( fp ) );
	fclose( fp );
	fprintf(stderr,"forward=%d\n",ctrl[CtrlCB_FORWARD].para[0]) ;
	fprintf(stderr,"forward=%d\n",ctrl[CtrlCB_BACK].para[0]) ;
	return( NORMAL_EXIT ) ;
}

/**********************************************************************
  Cone CeBOǂݍ
***********************************************************************/
int	cone_lightset( char *filename , struct Mapping_Vector *map_pt )
{
#include	"LightItem.h"
FILE	*fp;
char	s[20];
int	i;

	fp = fopen( filename, "rt" );
	if( fp==NULL ) return( FILE_OPEN_ERROR ) ;
	do {
		fscanf( fp, "%s = ", s );
		for( i=0; i<LightItemNum; i++ ){
			if( stricmp( s, LightItem[i] )==0 ){
				switch( i ){
				case 0:	fscanf( fp, "%lf\n", &(map_pt->vx0) );
					break;
				case 1:	fscanf( fp, "%lf\n", &(map_pt->vy0) );
					break;
				case 2:	fscanf( fp, "%lf\n", &(map_pt->vz0) );
					break;
				case 3:	fscanf( fp, "%lf\n", &(map_pt->ll) );
					break;
				case 4:	fscanf( fp, "%lf\n", &(map_pt->l0) );
					break;
				case 5:	fscanf( fp, "%lf\n", &(map_pt->hl) );
					break;
				case 6:	fscanf( fp, "%lf\n", &(map_pt->hk) );
					break;
				case 7:	fscanf( fp, "%d\n", &(map_pt->conelight) );
					break;
				case 8:	fscanf( fp, "%d\n", &(map_pt->lcx) );
					break;
				case 9:	fscanf( fp, "%d\n", &(map_pt->lcy) );
					break;
				case 10:fscanf( fp, "%d\n", &(map_pt->lcz) );
					break;
				}
				break;
			}
		}
	} while( !feof( fp ) );
	fclose( fp );
	return( NORMAL_EXIT ) ;
}

