/**********************************************************************
  SI2t@C̃[h && x[Xʂւ̍
  $Id: load_si2.c,v 1.6 1999/08/26 16:15:17 TANE Exp $
**********************************************************************/

#include	"common.h"
#include	"ovlap.h"
#include	"funcs.h"
#include	"saifile.h"

#define	HEADER_STR		"SAI_PLAN"
#define	HEADER_STR_LEN	8
#define	SAI_DOT_FORM_SIZE	(2)
#define	BUFF_DIV_MAX	1024


int	load_si2( struct VGRAM_STRUCT *vg_pt, char *file , struct LD_MODE_STRUCT *ld_md )
{
unsigned char	plan_header[] = HEADER_STR ;

FILE	*ifp ;
register int	i,j,n ;
unsigned char	r,g,b ;		/* ̃J[ */
unsigned char	rb,gb,bb ;	/* x[XJ[ */

short	flag ;
unsigned short	*tmp_file_pt ;
struct	PIX_STRUCT	*pix_pt ;
SAIHEADex	header ;

register short	vg_width ;
unsigned short	*in_img_tmp_pt ;
struct	ADJUST_STRUCT	adjust ;
int		img_dt_size ;
int		buff_div_num ;	/*** Height ***/
int		oper_line_num ;
short	vg_cur_line ;
short	mask_dt_work ;

	if( (ifp = fopen( file , "rb" )) == NULL ){
		fprintf(stderr,"t@C %s I[vł܂\n",file) ;
		return(FILE_OPEN_ERROR) ;
	}

	fread( &header , sizeof(SAIHEADex) , 1, ifp ) ;
	for( i=0 , flag=VALID ; i<HEADER_STR_LEN ; i++ ){
		if( header.sai_id[i] != plan_header[i] ) flag=INVALID ;
	}
	if( flag == INVALID ){
		fprintf(stderr,"ʃv[tH[}bgł͂܂\n") ;
		return( SI2_FORMAT_ERROR ) ;
	}

	adjust.vg_pt = vg_pt ;
	adjust.px = ld_md->px ;
	adjust.py = ld_md->py ;
	adjust.img_width  = header.nx ;
	adjust.img_height = header.ny ;
	if( ld_adjust( &adjust ) == OUT_OF_VGRAM ){
		fclose(ifp) ;
		return( NORMAL_EXIT ) ;
	}

	img_dt_size  = 0 ;
	in_img_tmp_pt = NULL ;
	for( buff_div_num=1 ; buff_div_num<=BUFF_DIV_MAX ; buff_div_num += buff_div_num ){
		img_dt_size = adjust.img_width * (adjust.height/buff_div_num) * SAI_DOT_FORM_SIZE ;
		in_img_tmp_pt = malloc( img_dt_size ) ;
		if( in_img_tmp_pt != NULL ) break ;
	}
	if( in_img_tmp_pt == NULL ){
		fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
		return(WORK_MEM_ALLOC_ERROR) ;
	}

	pix_pt = vg_pt->pix ;
	vg_width = vg_pt->width ;
	fseek( ifp,(adjust.img_width * adjust.height_adjust_U * SAI_DOT_FORM_SIZE), SEEK_CUR ) ;
	oper_line_num = adjust.height / buff_div_num ;
	vg_cur_line = adjust.sy ;

	switch( ld_md->oper ){
		case OVLAP_LINE :
			for( n=0 ; n<=buff_div_num ; n++ ){
				if( n == buff_div_num ){ /***ubN[vZ***/
					if( (adjust.height % buff_div_num) == 0 ) break ; /***[ꍇ***/
					img_dt_size = adjust.img_width * (adjust.height % buff_div_num) * SAI_DOT_FORM_SIZE ;
					oper_line_num = adjust.height % buff_div_num ;
				}
				fread( in_img_tmp_pt , img_dt_size , 1 , ifp ) ;
				tmp_file_pt = in_img_tmp_pt ;
				for( j=0 ; j<oper_line_num ; j++,vg_cur_line++ ){
					tmp_file_pt += (adjust.width_adjust_L*(SAI_DOT_FORM_SIZE/sizeof(*tmp_file_pt))) ;
					for( i=adjust.sx ; i<(adjust.sx+adjust.width) ; i++ ){
						mask_dt_work = (*tmp_file_pt/128) ;
						if( mask_dt_work>VALUE_MAX ) mask_dt_work=VALUE_MAX ;
						if( ld_md->rev == OFF ){
							mask_dt_work = VALUE_MAX - mask_dt_work ;
						}
						tmp_file_pt++ ;
						switch( mask_dt_work ){
							case 0:
								pix_pt[vg_cur_line*vg_width+i].r = ld_md->lr ;
								pix_pt[vg_cur_line*vg_width+i].g = ld_md->lg ;
								pix_pt[vg_cur_line*vg_width+i].b = ld_md->lb ;
								break ;
							case VALUE_MAX:
								break ;
							default:
								rb = pix_pt[vg_cur_line*vg_width+i].r ;
								r = mix_col( rb , ld_md->lr , mask_dt_work , VALUE_MAX ) ;
								pix_pt[vg_cur_line*vg_width+i].r = r ;

								gb = pix_pt[vg_cur_line*vg_width+i].g ;
								g = mix_col( gb , ld_md->lg , mask_dt_work , VALUE_MAX ) ;
								pix_pt[vg_cur_line*vg_width+i].g = g ;

								bb = pix_pt[vg_cur_line*vg_width+i].b ;
								b = mix_col( bb , ld_md->lb , mask_dt_work , VALUE_MAX ) ;
								pix_pt[vg_cur_line*vg_width+i].b = b ;
						}
					}
					tmp_file_pt += (adjust.width_adjust_R*(SAI_DOT_FORM_SIZE/sizeof(*tmp_file_pt))) ;
				}
			}
			break ;

		case OVLAP_LINE_TO_ATTR :
			for( n=0 ; n<=buff_div_num ; n++ ){
				if( n == buff_div_num ){ /***ubN[vZ***/
					if( (adjust.height % buff_div_num) == 0 ) break ; /***[ꍇ***/
					img_dt_size = adjust.img_width * (adjust.height % buff_div_num) * SAI_DOT_FORM_SIZE ;
					oper_line_num = adjust.height % buff_div_num ;
				}
				fread( in_img_tmp_pt , img_dt_size , 1 , ifp ) ;
				tmp_file_pt = in_img_tmp_pt ;
				for( j=0 ; j<oper_line_num ; j++,vg_cur_line++ ){
					tmp_file_pt += (adjust.width_adjust_L*(SAI_DOT_FORM_SIZE/sizeof(*tmp_file_pt))) ;
					for( i=adjust.sx ; i<(adjust.sx+adjust.width) ; i++ ){
						if( ld_md->rev == ON ){
							mask_dt_work = VALUE_MAX - (unsigned char)(*tmp_file_pt/128) ;
						}else{
							mask_dt_work = *tmp_file_pt/128 ;
						}
						tmp_file_pt++ ;
						mask_dt_work = (short)((short)pix_pt[vg_cur_line*vg_width+i].a + mask_dt_work) ;
						mask_dt_work = limit_max( mask_dt_work , VALUE_MAX ) ;
						pix_pt[vg_cur_line*vg_width+i].a = mask_dt_work ;
					}
					tmp_file_pt += (adjust.width_adjust_R*(SAI_DOT_FORM_SIZE/sizeof(*tmp_file_pt))) ;
				}
			}
			break ;

	}
	fclose(ifp) ;
	free( in_img_tmp_pt ) ;
	return( NORMAL_EXIT ) ;
}
