/*
 *	gettexB.c
 *	- eNX`}bv̐F𓾂
 *	  o`(Bilinear Interpolation)
 *	  Mar. 1995 - Jun. 1995
 *	  O@F (Oh!X)
 *
 *	layman modified by TANE
 *	$Id: pers_gettexb.c,v 1.2 1998/10/24 13:03:36 TANE Exp $
 */

#include	"common.h"
#include	"funcs.h"
#include	"math3D.h"
#include	"pers.h"
#include	"composit.h"

#define	BILINEARMAG	256
#define	W		((BILINEARMAG)*(BILINEARMAG))

extern mat3	A, A_;	/* SXebv̍sEts */
extern vec3	center;	/* g̒S */

extern int	a00, a01, a02, a10, a11, a12;
extern int	cu, cv;

/* o`ԂɂF߂ */
unsigned char	blend( struct VGRAM_STRUCT *vg_pt ,
                       CompositInfo *ci, int um, int vm, int ul, int vl, int mode )
{
int		r00, g00, b00, a00;
int		r01, g01, b01, a01;
int		r10, g10, b10, a10;
int		r11, g11, b11, a11;
int		um0, vm0, um1, vm1;
int		w00, w01, w10, w11;
struct PIX_STRUCT	p00, p01, p10, p11, *pix_pt;

	pix_pt = vg_pt->pix ;
	um0 = um;
	vm0 = vm;
	um1 = um+1;
	vm1 = vm+1;
//	if( mode ) {
		if( um0 == -1 ) um0 = (vg_pt->width -1);
		if( vm0 == -1 ) vm0 = (vg_pt->height-1);
		if( um1 == vg_pt->width  ) um1 = 0;
		if( vm1 == vg_pt->height ) vm1 = 0;
//	}else {
//		if( um0 == -1 ) um0 = 0;
//		if( vm0 == -1 ) vm0 = 0;
//		if( um1 == vg_pt->width  ) um1 = (vg_pt->width -1);
//		if( vm1 == vg_pt->height ) vm1 = (vg_pt->height-1);
//	}
	/* sNZl */
	p00 = pix_pt[vm0*vg_pt->width + um0];
	p01 = pix_pt[vm0*vg_pt->width + um1];
	p10 = pix_pt[vm1*vg_pt->width + um0];
	p11 = pix_pt[vm1*vg_pt->width + um1];
	/* RGB */
	r00=p00.r ; g00=p00.g ; b00=p00.b ; a00=p00.a ;
	r01=p01.r ; g01=p01.g ; b01=p01.b ; a01=p01.a ;
	r10=p10.r ; g10=p10.g ; b10=p10.b ; a10=p10.a ;
	r11=p11.r ; g11=p11.g ; b11=p11.b ; a11=p11.a ;
	/* ^ */
	w00 = (BILINEARMAG  -vl)*(BILINEARMAG  -ul);
	w01 = (BILINEARMAG  -vl)*(              ul);
	w10 = (              vl)*(BILINEARMAG  -ul);
	w11 = (              vl)*(              ul);

	ci->type = COMPOSIT_OVERWRITE;
	ci->r = (r00*w00 + r01*w01 + r10*w10 + r11*w11)/W;
	ci->g = (g00*w00 + g01*w01 + g10*w10 + g11*w11)/W;
	ci->b = (b00*w00 + b01*w01 + b10*w10 + b11*w11)/W;
	ci->a = (a00*w00 + a01*w01 + a10*w10 + a11*w11)/W;
	return ci->type;
}

int	getTexelBilinear( struct VGRAM_STRUCT *vg_pt ,
                      CompositInfo *ci, int x, int y, int z, int mode )
{
int	u, v;
int	xx, yy, zz;
int	um, ul, vm , vl;

	/* tϊŃeNX`W((BILINEARMAG){x)߂ */
	xx =  (x - (vg_pt->width /2)) * (ZSCALEV/GETA);
	yy = -(y - (vg_pt->height/2)) * (ZSCALEV/GETA);
	zz =  z*(VZ/GETA) - (ZSCALE/GETA);

	u =  (a00*xx + a01*yy + a02*zz + (cu + (vg_pt->width /2))*z)*BILINEARMAG/z;
	v = -(a10*xx + a11*yy + a12*zz + (cv - (vg_pt->height/2))*z)*BILINEARMAG/z;

	u = u % (vg_pt->width  * BILINEARMAG);
	v = v % (vg_pt->height * BILINEARMAG);
	if( u<0 ) u=(vg_pt->width  * BILINEARMAG) + u ;	//̏یŉ摜]̂}
	if( v<0 ) v=(vg_pt->height * BILINEARMAG) + v ;	//̏یŉ摜]̂}

	/* sNZWƃTusNZW(=o`Ԃ̌W) */
	ul = u%BILINEARMAG;	vl = v%BILINEARMAG;
	um = u/BILINEARMAG;	vm = v/BILINEARMAG;

	return blend( vg_pt , ci, um, vm, ul, vl, mode );
}
//		zoom = (VZ)*BILINEARMAG/z ;
