/*
 *	math3D.c
 *	- sExNgZ
 *	  Mar. 1995	O@F (Oh!X)
 */

#include	<stdio.h>
#include	<string.h>
#include	<math.h>
#include	"math3D.h"

#define	a	(*ap)
#define	b	(*bp)
#define	c	(*cp)
#define	A	(*Ap)
#define	A_	(*A_p)
#define	B	(*Bp)
#define	B_	(*B_p)
#define	C	(*Cp)
#define	C_	(*C_p)

/* s  A = O */
void	zeroM3( Ap )
mat3	*Ap;
{
	A[0][0] = 0.0; A[0][1] = 0.0; A[0][2] = 0.0;
	A[1][0] = 0.0; A[1][1] = 0.0; A[1][2] = 0.0;
	A[2][0] = 0.0; A[2][1] = 0.0; A[2][2] = 0.0;
	return;
}

/* Pʍs  A = E */
void	unitM3( Ap )
mat3	*Ap;
{
	A[0][0] = 1.0; A[0][1] = 0.0; A[0][2] = 0.0;
	A[1][0] = 0.0; A[1][1] = 1.0; A[1][2] = 0.0;
	A[2][0] = 0.0; A[2][1] = 0.0; A[2][2] = 1.0;
	return;
}

/* xNg  a = o */
void	zeroV3( ap )
vec3	*ap;
{
	a[0] = 0.0; a[1] = 0.0; a[2] = 0.0;
	return;
}

/*	]s
 *	  A = Rx()
 *	  A = Ry()
 *	  A = Rz() */
void	xrotM3( Ap, A_p, theta )
mat3	*Ap, *A_p;
double	theta;
{
	double	ct, st;

	ct = cos( theta );
	st = sin( theta );

	A[0][0] = 1.0; A[0][1] = 0.0; A[0][2] = 0.0;
	A[1][0] = 0.0; A[1][1] =  ct; A[1][2] = -st;
	A[2][0] = 0.0; A[2][1] =  st; A[2][2] =  ct;

	A_[0][0] = 1.0; A_[0][1] = 0.0; A_[0][2] = 0.0;
	A_[1][0] = 0.0; A_[1][1] =  ct; A_[1][2] =  st;
	A_[2][0] = 0.0; A_[2][1] = -st; A_[2][2] =  ct;

	return;
}

void	yrotM3( Ap, A_p, theta )
mat3	*Ap, *A_p;
double	theta;
{
	double	ct, st;

	ct = cos( theta );
	st = sin( theta );

	A[0][0] =  ct; A[0][1] = 0.0; A[0][2] =  st;
	A[1][0] = 0.0; A[1][1] = 1.0; A[1][2] = 0.0;
	A[2][0] = -st; A[2][1] = 0.0; A[2][2] =  ct;

	A_[0][0] =  ct; A_[0][1] = 0.0; A_[0][2] = -st;
	A_[1][0] = 0.0; A_[1][1] = 1.0; A_[1][2] = 0.0;
	A_[2][0] =  st; A_[2][1] = 0.0; A_[2][2] =  ct;

	return;
}

void	zrotM3( Ap, A_p, theta )
mat3	*Ap, *A_p;
double	theta;
{
	double	ct, st;

	ct = cos( theta );
	st = sin( theta );

	A[0][0] =  ct; A[0][1] = -st; A[0][2] = 0.0;
	A[1][0] =  st; A[1][1] =  ct; A[1][2] = 0.0;
	A[2][0] = 0.0; A[2][1] = 0.0; A[2][2] = 1.0;

	A_[0][0] =  ct; A_[0][1] =  st; A_[0][2] = 0.0;
	A_[1][0] = -st; A_[1][1] =  ct; A_[1][2] = 0.0;
	A_[2][0] = 0.0; A_[2][1] = 0.0; A_[2][2] = 1.0;

	return;
}

/* sRs[  A = B */
void	copyM3( Ap, Bp )
mat3	*Ap, *Bp;
{
	memcpy( Ap, Bp, sizeof(mat3) );
	return;
}

/* xNgRs[  a = b */
void	copyV3( ap, bp )
vec3	*ap, *bp;
{
	memcpy( ap, bp, sizeof(vec3) );
	return;
}

/* xNg̘a  a = b + c */
void	addV3( ap, bp, cp )
vec3	*ap, *bp, *cp;
{
	a[0] = b[0] + c[0];
	a[1] = b[1] + c[1];
	a[2] = b[2] + c[2];
	return;
}

/* xNg̍  a = b - c */
void	subV3( ap, bp, cp )
vec3	*ap, *bp, *cp;
{
	a[0] = b[0] - c[0];
	a[1] = b[1] - c[1];
	a[2] = b[2] - c[2];
	return;
}

/* sƃxNg̐  a = Bc */
void	prodMV3( ap, Bp, cp )
vec3	*ap, *cp;
mat3	*Bp;
{
	a[0] = B[0][0]*c[0] + B[0][1]*c[1] + B[0][2]*c[2];
	a[1] = B[1][0]*c[0] + B[1][1]*c[1] + B[1][2]*c[2];
	a[2] = B[2][0]*c[0] + B[2][1]*c[1] + B[2][2]*c[2];
	return;
}

/* s̐  A = BC */
void	prodMM3( Ap, Bp, Cp )
mat3	*Ap, *Bp, *Cp;
{
	A[0][0] = B[0][0]*C[0][0] + B[0][1]*C[1][0] + B[0][2]*C[2][0];
	A[0][1] = B[0][0]*C[0][1] + B[0][1]*C[1][1] + B[0][2]*C[2][1];
	A[0][2] = B[0][0]*C[0][2] + B[0][1]*C[1][2] + B[0][2]*C[2][2];

	A[1][0] = B[1][0]*C[0][0] + B[1][1]*C[1][0] + B[1][2]*C[2][0];
	A[1][1] = B[1][0]*C[0][1] + B[1][1]*C[1][1] + B[1][2]*C[2][1];
	A[1][2] = B[1][0]*C[0][2] + B[1][1]*C[1][2] + B[1][2]*C[2][2];

	A[2][0] = B[2][0]*C[0][0] + B[2][1]*C[1][0] + B[2][2]*C[2][0];
	A[2][1] = B[2][0]*C[0][1] + B[2][1]*C[1][1] + B[2][2]*C[2][1];
	A[2][2] = B[2][0]*C[0][2] + B[2][1]*C[1][2] + B[2][2]*C[2][2];

	return;
}
