/**********************************************************************
  bmp Z[u(24bit Z[ûݔ)
  $Id: save_bmp.c,v 1.7 1998/11/13 14:46:48 TANE Exp $
**********************************************************************/

#include	"common.h"
#include	"filetype.h"
#include	"save.h"
#include	"funcs.h"

#define	FNAME_LENG	1024
#define	FILE_NUM	64
#define	BMP_HEADER_SIZE	0x36
#define	BMP_COL_DEPTH	3	//tJ[̂
#define	BUFF_DIV_MAX	1024

int	save_bmp( struct VGRAM_STRUCT *vg_pt, char *file , struct SV_MODE_STRUCT *sv_md )
{
FILE	*ofp ;
gzFile	ogzfp ;
char	gzfmode[8] ;
short	i,n,line ;
int		j ;
int		buff_div_num ;	/*** Height ***/
int		oper_line_num ;
short	height , width ;
unsigned char	*out_img_pt , *workp ;
register struct	PIX_STRUCT	*pix_pt ;
int		img_dt_size ;
int		padding_width ;
unsigned int	file_size ;

static	unsigned char	bmp_header[BMP_HEADER_SIZE] = {
		0x42,0x4D,0x36,0x00,0x0C,0x00,0x00,0x00,
		0x00,0x00,0x36,0x00,0x00,0x00,0x28,0x00,
		0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x02,
		0x00,0x00,0x01,0x00,0x18,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00 } ;

 width  = sv_md->x1 - sv_md->x0 + 1 ;
 height = sv_md->y1 - sv_md->y0 + 1 ;
 
 /* 4byte EACg */
 if( (width * BMP_COL_DEPTH)%4 != 0 ){
   padding_width = ((width * BMP_COL_DEPTH)/4 +1 )* 4 ;
 }else{
   padding_width = width * BMP_COL_DEPTH ;
 }
 
 img_dt_size = 0 ;
 out_img_pt = NULL ;
 for( buff_div_num=1 ; buff_div_num<=BUFF_DIV_MAX ; buff_div_num += buff_div_num ){
   img_dt_size = padding_width * (height/buff_div_num)  ;
   out_img_pt = malloc( img_dt_size ) ;
   if( out_img_pt != NULL ) break ;
 }
 
 if( out_img_pt == NULL ){
   fprintf(stderr,"Ɨ̈mۂł܂ł") ;
   fprintf(stderr,"saveR}h̎sɎs܂\n") ;
   return(WORK_MEM_ALLOC_ERROR) ;
 }
 
 ofp   = NULL ;
 ogzfp = NULL ;
 if( strcmp( file , (char*)"-" ) == 0 ){
   setmode( fileno(stdout),O_BINARY ) ;
   ofp = stdout ;
 }else{
   if( (sv_md->fmt & GZIPED_FILE)==0 ){
     if( (ofp = fopen( file , "wb" )) == NULL ){
       fprintf(stderr,"o̓t@C %s I[vł܂\n",file) ;
       return(FILE_OPEN_ERROR) ;
     }
   }else{
     sprintf( gzfmode, "wb%d",sv_md->compression_level ) ;
     if( (ogzfp = gzopen( file , gzfmode )) == NULL ){
       fprintf(stderr,"o̓t@C %s I[vł܂\n",file) ;
       return(FILE_OPEN_ERROR) ;
     }
   }
 }
 
 /* wb_(vgGfBAΉ) */
 /* t@CTCY */
 file_size = BMP_HEADER_SIZE + img_dt_size ;
 bmp_header[5]  = (file_size & 0xff000000) >> 24 ;
 bmp_header[4]  = (file_size & 0x00ff0000) >> 16 ;
 bmp_header[3]  = (file_size & 0x0000ff00) >> 8  ;
 bmp_header[2]  = (file_size & 0x000000ff) ;
 
 /* C[W */
 bmp_header[21] = 0 ;
 bmp_header[20] = 0 ;
 bmp_header[19] = (unsigned char)((unsigned )width / 256) ;
 bmp_header[18] = (unsigned char)((unsigned )width % 256) ;
 
 /* C[W */
 bmp_header[25] = 0 ;
 bmp_header[24] = 0 ;
 bmp_header[23] = (unsigned char)((unsigned )height / 256) ;
 bmp_header[22] = (unsigned char)((unsigned )height % 256) ;
 
 if( (sv_md->fmt & GZIPED_FILE)==0 ){
   fwrite( bmp_header , BMP_HEADER_SIZE , 1 , ofp ) ;
 }else{
   gzwrite( ogzfp , bmp_header , BMP_HEADER_SIZE ) ;
 }
 
 pix_pt = vg_pt->pix ;
 
 oper_line_num = height / buff_div_num ;
 line = sv_md->y1 ;
 for( n=0 ; n<=buff_div_num ; n++ ){
   if( n == buff_div_num ){ /***ubN[vZ***/
     if( (height % buff_div_num) == 0 ) break ; /***[ꍇ***/
     img_dt_size = padding_width * (height % buff_div_num) ;
     oper_line_num = height % buff_div_num ;
   }
   for( j=0 ; j < oper_line_num ; j++ , line-- ){
     workp = out_img_pt + j*padding_width ;
     for( i=sv_md->x0 ; i<=sv_md->x1 ; i++ ){
       *workp++ = pix_pt[i+line*vg_pt->width].b ; // B
       *workp++ = pix_pt[i+line*vg_pt->width].g ; // G
       *workp++ = pix_pt[i+line*vg_pt->width].r ; // R
     }
   }
   if( (sv_md->fmt & GZIPED_FILE)==0 ){
     fwrite( out_img_pt , img_dt_size , 1 , ofp ) ;
   }else{
     gzwrite( ogzfp , out_img_pt , img_dt_size ) ;
   }
 }
 
 if( (sv_md->fmt & GZIPED_FILE)==0 ){
   if( ofp != stdout ){
     fclose( ofp ) ;
   }else{
     setmode( fileno(stdout),O_TEXT ) ;
   }
 }else{
   gzclose( ogzfp ) ;
 }
 free( out_img_pt ) ;
 return( NORMAL_EXIT ) ;
}
