/**********************************************************************
  JPEGZ[u
  $Id: save_jpg.c,v 1.8 1998/11/20 15:11:41 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"vg_getput.h"
#include	"save.h"
#include	"funcs.h"
#include	"jpeglib.h"

#define	RGB_COL_DEPTH	3
#define	GRAY_COL_DEPTH	1

int save_jpg( struct VGRAM_STRUCT *vg_pt, char *file , struct SV_MODE_STRUCT *sv_md )
{
unsigned char	*tmp_buff ;
struct	jpeg_compress_struct cinfo;
struct	jpeg_error_mgr jerr ;

FILE	*outfile;
struct	GETPUT_MODE	mode ;
struct	PIX_STRUCT	*pix_pt ;
int		y ;

 jpeg_create_compress(&cinfo);
 
 if( strcmp( file , (char*)"-" ) == 0 ){
   setmode( fileno(stdout),O_BINARY ) ;
   outfile = stdout ;
 }else{
   if((outfile = fopen(file, "wb")) == NULL){
     fprintf(stderr,"o̓t@C %s I[vł܂\n",file) ;
     return(FILE_OPEN_ERROR) ;
   }
 }
 
 init_mode( &mode ) ;
 
 jpeg_stdio_dest(&cinfo, outfile);
 
 cinfo.image_width  = sv_md->x1 - sv_md->x0 + 1 ;
 cinfo.image_height = sv_md->y1 - sv_md->y0 + 1 ;
 if( sv_md->save_type == SAVE_GRAY_IMAGE ){
   cinfo.input_components = GRAY_COL_DEPTH ;
   cinfo.in_color_space = JCS_GRAYSCALE ;
   jpeg_set_defaults(&cinfo);
   mode.buf_type = GRAY_8BIT ;
 }else{
   cinfo.input_components = RGB_COL_DEPTH ;
   cinfo.in_color_space   = JCS_RGB ;
   jpeg_set_defaults(&cinfo);
   cinfo.comp_info[0].h_samp_factor = sv_md->sample_h;
   cinfo.comp_info[0].v_samp_factor = sv_md->sample_v;
   mode.buf_type = RGB_8BIT ;
 }
 
 cinfo.err = jpeg_std_error(&jerr);
 jpeg_set_quality(&cinfo, sv_md->quality, TRUE ) ;
 cinfo.smoothing_factor = sv_md->smooth ;
 cinfo.optimize_coding  = sv_md->optimize_coding ;
 jpeg_start_compress(&cinfo, TRUE);
 
 tmp_buff = malloc( cinfo.image_width * cinfo.input_components ) ;
 if( tmp_buff == NULL ){
   fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
   jpeg_finish_compress(&cinfo);
   jpeg_destroy_compress(&cinfo);
   fclose( outfile );
   return(WORK_MEM_ALLOC_ERROR) ;
 }
 
 pix_pt = vg_pt->pix ;
 y=sv_md->y0 ;
 while( cinfo.next_scanline < cinfo.image_height ){
   vg_get_rect( vg_pt , tmp_buff , sv_md->x0 , y , cinfo.image_width , 1 , &mode ) ;
   jpeg_write_scanlines(&cinfo, (JSAMPARRAY)&tmp_buff, 1 );
   y++ ;
 }
 
 jpeg_finish_compress(&cinfo);
 jpeg_destroy_compress(&cinfo);
 
 free( tmp_buff ) ;
 if( outfile != stdout ){
   fclose( outfile );
 }else{
   setmode( fileno(stdout),O_TEXT ) ;
 }

 return( NORMAL_EXIT ) ;
}
