/***********************************************************************
 *	EX-Window Ver.2.0 X file.
 *	(c) i.kikuchi & i.yoshida
 *
    24bit Color modified for layman
    $Id: sphere.c,v 1.5 1999/05/31 15:45:11 TANE Exp $
************************************************************************/

#include	"common.h"
#include	"funcs.h"
#include	"sphere.h"
#include	"3DMap.h"
#include	<math.h>

#include	"Equation.h"

#ifndef	PI
#define	PI	3.1415926535898
#endif

int		sphere_lightset( char* , struct	Mapping_Vector * );
int		Sphere_main( struct VGRAM_STRUCT * , struct	Mapping_Vector * );
int		sphere_load( char* , struct	Mapping_Vector * );

#define	SPHERE_CNTL_NUM	26
static	struct {
	int		type;
	char	str[36];
	int		para[2];
} ctrl[] = {
	{ 8,	"wa",		{	-3, 0 }, },	/* ID  0 */
	{ 7,	"",				{	 1, 0 }, },	/* ID  1 */
	{ 8,	"xa",		{	-3, 0 }, },	/* ID  2 */
	{ 7,	"",				{	 1, 0 }, },	/* ID  3 */
	{ 8,	"ȋ]",		{	-3, 0 }, },	/* ID  4 */
	{ 3,	"",				{65534, 0 }, },	/* ID  5 */
	{ 7,	"",				{	 1, 0 }, },	/* ID  6 */
	{ 5,	"",				{	 1, 0 }, },	/* ID  7 */
	{ 8,	"Shading",		{	-3, 0 }, },	/* ID  8 */
	{ 2,	"ײèݸސݒ",	{	 1, 0 }, },	/* ID  9 */
	{ 5,	"",				{	 0, 0 }, },	/* ID 10 */
	{ 8,	"Mapping",		{	-3, 0 }, },	/* ID 11 */
	{ 5,	"",				{	 1, 0 }, },	/* ID 12 */
	{ 8,	"Texture",		{	-3, 0 }, },	/* ID 13 */
	{ 5,	"",				{	 0, 0 }, },	/* ID 14 */
	{ 8,	"Bump",			{	-3, 0 }, },	/* ID 15 */
	{ 5,	"",				{	 1, 0 }, },	/* ID 16 */
	{ 8,	"Forward",		{	-3, 0 }, },	/* ID 17 */
	{ 5,	"",				{	 1, 0 }, },	/* ID 18 */
	{ 8,	"Back",			{	-3, 0 }, },	/* ID 19 */
	{ 6,	"",				{	 1, 1 }, },	/* ID 20 */
	{ 2,	"s",			{	 1, 0 }, },	/* ID 21 */
	{ 8,	"yʒu",		{	-3, 0 }, },	/* ID 22 */
	{ 3,	"",				{65534, 0 }, }, /* ID 23 */
	{ 7,	"",				{	 1, 0 }, },	/* ID 24 */
	{ 2,	"File",			{	 1, 0 }, },	/* ID 25 */
	{ 2,	"2",			{	 1, 0 }, }	/* ID 26 */
};

typedef enum CtrlNo {
	CtrlLB_XR,
	CtrlTB_XR,
	CtrlLB_YR,
	CtrlTB_YR,
	CtrlLB_BANK,
	CtrlHS_BANK,
	CtrlTB_BANK,
	CtrlCB_SHADE,
	CtrlLB_SHADE,
	CtrlBT_LIGHTSET,
	CtrlCB_MAP,
	CtrlLB_MAP,
	CtrlCB_TEXTURE,
	CtrlLB_TEXTURE,
	CtrlCB_BUMP,
	CtrlLB_BUMP,
	CtrlCB_FORWARD,
	CtrlLB_FORWARD,
	CtrlCB_BACK,
	CtrlLB_BACK,
	CtrlCC_SAMPLE,
	CtrlBT_EXEC,
	CtrlLB_ZPOS,
	CtrlHS_ZPOS,
	CtrlTB_ZPOS,
	CtrlBT_FILE,
	CtrlBT_BUMPLEVEL,
} CtrlNo;


int		shadow_mode , hilight_mode , draw_mode , ovlap_mode ;

/**********************************************************************
  Sphere lݒ
***********************************************************************/
int	sphere( struct VGRAM_STRUCT *vg_pt , struct SPHERE_EXEC_STRUCT *exec_info )
{
struct	Mapping_Vector map_dt , *map_pt ;

	map_pt = &map_dt ;
	if( exec_info->rend_file[0] != '\0' ){
		if( sphere_load( exec_info->rend_file , map_pt ) != NORMAL_EXIT ){
			fprintf( stderr,"t@C %s I[vł܂łBftHglgp܂B\n",exec_info->rend_file ) ;
		}
	}
	if( exec_info->light_file[0] != '\0' ){
		if( sphere_lightset( exec_info->light_file , map_pt ) != NORMAL_EXIT ){
			fprintf( stderr,"t@C %s I[vł܂łBftHglgp܂B\n",exec_info->light_file ) ;
		}
	}

	map_pt->sx0 = exec_info->sx ;
	map_pt->sy0 = exec_info->sy ;
	map_pt->ex0 = exec_info->ex ;
	map_pt->ey0 = exec_info->ey ;
	map_pt->org_r = exec_info->r ;
	map_pt->org_g = exec_info->g ;
	map_pt->org_b = exec_info->b ;

	if( exec_info->posx>=0 ) map_pt->cx = exec_info->posx ;
	if( exec_info->posy>=0 ) map_pt->cy = exec_info->posy ;
	if( exec_info->rx>=0 )   map_pt->rx = exec_info->rx ;
	if( exec_info->ry>=0 )   map_pt->ry = exec_info->ry ;

	shadow_mode = exec_info->shadow_mode ;
	hilight_mode = exec_info->hilight_mode ;
	draw_mode  = exec_info->draw_mode ;
	ovlap_mode = exec_info->ovlap_mode ;

	if( draw_mode == MAPPING ) ctrl[CtrlCB_MAP].para[0] = 1 ;
	if( draw_mode == NO_MAPPING ) ctrl[CtrlCB_MAP].para[0] = 0 ;
	if( exec_info->shade_mode == OFF ) ctrl[CtrlCB_SHADE].para[0] = 0 ;

	if( ctrl[CtrlCB_FORWARD].para[0] == 1 ){ //tOĂBACKDŕ`Ă܂
		ctrl[CtrlCB_BACK].para[0] = 0 ;
	}

	Sphere_main( vg_pt , map_pt );

	return( NORMAL_EXIT );
}


/**********************************************************************
  Sphere _O{
***********************************************************************/
int		Sphere_main( struct VGRAM_STRUCT *vg_pt , struct Mapping_Vector *map_pt )
{
int		x, y, ox1, oy1, ox2, oy2, x1, y1;
int		sx, sy, cx0, cy0, rx0, ry0;
double	x00, y00, x01, y01, x02, y02, xx, yy, r0, rr;
double	sinrth, cosrth;
int		face, result, tmp;

int		cx, cy, rx, ry, zpos ;
int		sx0, sy0, ex0, ey0;
double	vx0, vy0, vz0, l0, ll;
double	hl, hk;
int		lcx, lcy, lcz, conelight ;
double	vx, vy, vz ;
int		rth, bumplevel ;
unsigned int	org_r, org_g, org_b ;

int		width,height ;
struct	VGRAM_STRUCT vg_tmp , *vg_tmp_pt ;
int		exec_status ;

	vg_tmp_pt = &vg_tmp ;
	vg_alloc( vg_tmp_pt , vg_pt->width , vg_pt->height ) ;
	if( vg_tmp_pt->pix == NULL ){
		fprintf(stderr,"Ɨ̈̊mۂɎs܂\n") ;
		return( VGRAM_WORK_ALLOC_ERROR ) ;
	}
	if( ovlap_mode == OFF ){
		vg_clr( vg_tmp_pt , 0,0,0, VALUE_MAX ) ;
	}else{
		vg_cpy( vg_tmp_pt , vg_pt ) ;
	}

	cx = map_pt->cx ;
	cy = map_pt->cy ;
	rx = map_pt->rx ;
	ry = map_pt->ry ;
	zpos = map_pt->zpos ;
	sx0 = map_pt->sx0 ;
	sy0 = map_pt->sy0 ;
	ex0 = map_pt->ex0 ;
	ey0 = map_pt->ey0 ;
	lcx = map_pt->lcx ;
	lcy = map_pt->lcy ;
	lcz = map_pt->lcz ;
	conelight = map_pt->conelight ;
	rth = map_pt->rth ;
	vx0 = map_pt->vx0 ;
	vy0 = map_pt->vy0 ;
	vz0 = map_pt->vz0 ;
	l0 = map_pt->l0 ;
	ll = map_pt->ll ;
	hl = map_pt->hl ;
	hk = map_pt->hk ;
	vx = map_pt->vx ;
	vy = map_pt->vy ;
	vz = map_pt->vz ;
	bumplevel = map_pt->bumplevel ;
	org_r = map_pt->org_r ;
	org_g = map_pt->org_g ;
	org_b = map_pt->org_b ;

	width  = vg_pt->width ;
	height = vg_pt->height ;

	if( rx==0 || ry==0 ) return( NORMAL_EXIT ) ;

	result = 0;
	ox1 = 0 ;
	oy1 = 0 ;
	ox2 = 0 ;
	oy2 = 0 ;

	if( conelight ){
		vx0 = (lcx-cx)?(lcx-cx):0.0;
		vy0 = (lcy-cy)?(lcy-cy):0.0;
		vz0 = (zpos-lcz)?(zpos-lcz):0.0;
		if( vx0==0.0 && vy0==0.0 && vz0==0.0 ) vz0 = 1.0;
	}
	cx0 = (ex0+sx0)/2;
	cy0 = (ey0+sy0)/2;
	rx0 = cx0-sx0;
	ry0 = cy0-sy0;
	if( rx0<0 ) rx0 = -rx0;
	if( ry0<0 ) ry0 = -ry0;
	cx0 <<= 4;
	cy0 <<= 4;
	sinrth = sin( (double)PI*rth/180.0 );
	cosrth = cos( (double)PI*rth/180.0 );
	sx = rx*fabs(cosrth)+ry*fabs(sinrth)+1;
	sy = ry*fabs(cosrth)+rx*fabs(sinrth)+1;
	for( y=-sy; y<=sy; y++ ){
		y1 = cy+y;
		if( y1<0 || y1>(height-1) ) continue;
		for( x=-sx; x<=sx; x++ ){
			x1 = cx+x;
			if( x1<0 || x1>(width-1) ) continue;
			x00 = (double)x*cosrth+(double)y*sinrth;
			y00 = (double)y*cosrth-(double)x*sinrth;
			y00 *= (double)rx/(double)ry;
			xx = fabs( x00 ) - 0.5;
			yy = fabs( y00 ) - 0.5;
			r0 = sqrt( xx*xx+yy*yy );
			if( r0>(double)rx ) continue;

			if( ctrl[CtrlCB_SHADE].para[0] ){		/* Shading */
				r0 = sqrt( x00*x00+y00*y00 );
				if( r0>(double)rx ){
					vz=1 ;
				}else{
					vz = sqrt( rx*rx-r0*r0 );
				}
			}

			if( ctrl[CtrlCB_MAP].para[0] ){		/* Mapping */
				x01 = x00-0.5;
				y01 = y00-0.5*(double)rx/(double)ry;
				r0 = sqrt( x01*x01+y01*y01 );
				if( r0>(double)rx ) r0 = rx;
				if( r0==0 ) ox1 = oy1 = 0;
				else {
					rr = r0/(double)rx;
					rr = asin( rr );
					rr *= (double)2*(double)rx0/(double)PI;
					xx = x01*rr/r0;
					yy = y01*rr/r0;
					yy *= (double)ry0/(double)rx0;
					ox1 = (int)(xx*(double)16);
					oy1 = (int)(yy*(double)16);
				}
				x02 = x00+0.5;
				y02 = y00+0.5*(double)rx/(double)ry;
				r0 = sqrt( x02*x02+y02*y02 );
				if( r0>(double)rx ) r0 = rx;
				if( r0==0 ) ox2 = oy2 = 0;
				else {
					rr = r0/(double)rx;
					rr = asin( rr );
					rr *= (double)2*(double)rx0/(double)PI;
					xx = x02*rr/r0;
					yy = y02*rr/r0;
					yy *= (double)ry0/(double)rx0;
					ox2 = (int)(xx*(double)16);
					oy2 = (int)(yy*(double)16);
				}
			}
			if( ctrl[CtrlCB_MAP].para[0]==0 ){
				if( draw_mode == LIGHTING_ONLY ){
					map_pt->r = vg_pt->pix[x1+y1*width].r ;
					map_pt->g = vg_pt->pix[x1+y1*width].g ;
					map_pt->b = vg_pt->pix[x1+y1*width].b ;
				}else{
					map_pt->r = org_r ;
					map_pt->g = org_g ;
					map_pt->b = org_b ;
				}
				if( ctrl[CtrlCB_SHADE].para[0] ){
					vx = x00*cosrth-y00*sinrth;
					vy = y00*cosrth+x00*sinrth;
					map_pt->vx0 = vx0 ;
					map_pt->vy0 = vy0 ;
					map_pt->vz0 = vz0 ;
					map_pt->l0 = l0 ;
					map_pt->ll = ll ;
					map_pt->hl = hl ;
					map_pt->hk = hk ;
					map_pt->vx = vx ;
					map_pt->vy = vy ;
					map_pt->vz = vz ;
					Shade( x1, y1, shadow_mode, hilight_mode, map_pt );
				}
			}else{
				ox1 += cx0; oy1 += cy0;
				ox2 += cx0; oy2 += cy0;
				for( face=0; face<=1; face++ ){
					if( face != 0 ){
						if( ctrl[CtrlCB_BACK].para[0]==0 ) continue;
						ox1 = 2*cx0-ox1;
						ox2 = 2*cx0-ox2;
						x00 = -x00;
						y00 = -y00;
					} else if( ctrl[CtrlCB_FORWARD].para[0]==0 ) continue;
					vx = x00*cosrth-y00*sinrth;
					vy = y00*cosrth+x00*sinrth;
					if( ox1>ox2 ){ tmp = ox1; ox1 = ox2; ox2 = tmp; }
					if( oy1>oy2 ){ tmp = oy1; oy1 = oy2; oy2 = tmp; }

					map_pt->vx0 = vx0 ;
					map_pt->vy0 = vy0 ;
					map_pt->vz0 = vz0 ;
					map_pt->l0 = l0 ;
					map_pt->ll = ll ;
					map_pt->hl = hl ;
					map_pt->hk = hk ;
					map_pt->vx = vx ;
					map_pt->vy = vy ;
					map_pt->vz = vz ;
					map_pt->bumplevel = bumplevel ;

					if( ctrl[CtrlCB_TEXTURE].para[0] )	/* Texture */
					result = TextureMap( ox1, oy1, ox2, oy2, vg_pt , map_pt );
					if( ctrl[CtrlCB_BUMP].para[0] )		/* Bump */
					result = BumpMap( ox1, oy1, ox2, oy2, face, 0, vg_pt, map_pt );

					if( result==0 && ctrl[CtrlCB_SHADE].para[0] ){
						vx = x00*cosrth-y00*sinrth;
						vy = y00*cosrth+x00*sinrth;
						map_pt->vx = vx ;
						map_pt->vy = vy ;
						Shade( x1, y1, shadow_mode, hilight_mode, map_pt );
					}
				}
			}

			vg_tmp_pt->pix[x1+y1*width].r = map_pt->r ;
			vg_tmp_pt->pix[x1+y1*width].g = map_pt->g ;
			vg_tmp_pt->pix[x1+y1*width].b = map_pt->b ;
			if( ovlap_mode == OFF )	vg_tmp_pt->pix[x1+y1*width].a = 0 ;
		}
	}

	vg_cpy( vg_pt , vg_tmp_pt ) ;
	exec_status = vg_free( vg_tmp_pt ) ;
	return( NORMAL_EXIT ) ;
}

/**********************************************************************
  Sphere _O`ǂݍ
***********************************************************************/
int	sphere_load( char *filename , struct Mapping_Vector *map_pt )
{
#include	"SphereItem.h"
	FILE	*fp;
	char	s[20];
	int	i;

	fp = fopen( filename, "rt" );
	if( fp==NULL ) return( FILE_OPEN_ERROR );

	do {
		fscanf( fp, "%s = ", s );
		for( i=0; i<SphereItemNum; i++ ){
			if( stricmp( s, SphereItem[i] )==0 ){
				switch( i ){
				case 0:	fscanf( fp, "%d\n", &(map_pt->cx) );
					break;
				case 1:	fscanf( fp, "%d\n", &(map_pt->cy) );
					break;
				case 2:	fscanf( fp, "%d\n", &(map_pt->rx) );
					break;
				case 3:	fscanf( fp, "%d\n", &(map_pt->ry) );
					break;
				case 4:	fscanf( fp, "%d\n", &(map_pt->rth) );
					break;
				case 5:	fscanf( fp, "%d\n", &(map_pt->zpos) );
					break;
				case 6:	fscanf( fp, "%d\n", &ctrl[CtrlCB_SHADE].para[0] );
					break;
				case 7:	fscanf( fp, "%d\n", &ctrl[CtrlCB_MAP].para[0] );
					break;
				case 8:	fscanf( fp, "%d\n", &ctrl[CtrlCB_TEXTURE].para[0] );
					break;
				case 9:	fscanf( fp, "%d\n", &ctrl[CtrlCB_BUMP].para[0] );
					break;
				case 10:fscanf( fp, "%d\n", &(map_pt->bumplevel) );
					break;
				case 11:fscanf( fp, "%d\n", &ctrl[CtrlCB_FORWARD].para[0] );
					break;
				case 12:fscanf( fp, "%d\n", &ctrl[CtrlCB_BACK].para[0] );
					break;
				}
				break;
			}
		}
	} while( !feof( fp ) );
	fclose( fp );
	return( NORMAL_EXIT ) ;
}

/**********************************************************************
  Sphere CeBOǂݍ
***********************************************************************/
int	sphere_lightset( char *filename , struct Mapping_Vector *map_pt )
{
#include	"LightItem.h"
FILE	*fp;
char	s[20];
int	i;

	fp = fopen( filename, "rt" );
	if( fp==NULL ) return( FILE_OPEN_ERROR ) ;
	do {
		fscanf( fp, "%s = ", s );
		for( i=0; i<LightItemNum; i++ ){
			if( stricmp( s, LightItem[i] )==0 ){
				switch( i ){
				case 0:	fscanf( fp, "%lf\n", &(map_pt->vx0) );
					break;
				case 1:	fscanf( fp, "%lf\n", &(map_pt->vy0) );
					break;
				case 2:	fscanf( fp, "%lf\n", &(map_pt->vz0) );
					break;
				case 3:	fscanf( fp, "%lf\n", &(map_pt->ll) );
					break;
				case 4:	fscanf( fp, "%lf\n", &(map_pt->l0) );
					break;
				case 5:	fscanf( fp, "%lf\n", &(map_pt->hl) );
					break;
				case 6:	fscanf( fp, "%lf\n", &(map_pt->hk) );
					break;
				case 7:	fscanf( fp, "%d\n", &(map_pt->conelight) );
					break;
				case 8:	fscanf( fp, "%d\n", &(map_pt->lcx) );
					break;
				case 9:	fscanf( fp, "%d\n", &(map_pt->lcy) );
					break;
				case 10:fscanf( fp, "%d\n", &(map_pt->lcz) );
					break;
				}
				break;
			}
		}
	} while( !feof( fp ) );
	fclose( fp );
	return( NORMAL_EXIT ) ;
}

