/**********************************************************************
  vg_put_rect
  $Id: vg_put_rect.c,v 1.2 1998/10/16 13:51:35 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"funcs.h"
#include	"vg_getput.h"

void put_rgb_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void put_rgba_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void put_rgb_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void put_rgba_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void put_gray_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void put_gray_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void put_mask_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void put_mask_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;

/**********************************************************************/
int	vg_put_rect( struct VGRAM_STRUCT *vg_pt, void *buf,
                 int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
struct	MODE_TBL_STRUCT{
	void (*func)() ;
} ;
static	struct	MODE_TBL_STRUCT	getput_mode_tbl[] ={
	{ put_rgb_8bit }	,
	{ put_rgba_8bit }	,
	{ put_rgb_16bit }	,
	{ put_rgba_16bit }	,
	{ put_gray_8bit }	,
	{ put_gray_16bit }	,
	{ put_mask_8bit }	,
	{ put_mask_16bit }
} ;

	(*getput_mode_tbl[mode->buf_type].func)( vg_pt, buf, sx, sy, width, height, mode ) ;
	return( NORMAL_EXIT ) ;
}

/**********************************************************************/
void put_rgb_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                  int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
register short	x,y ;
register int	i,j ;
int		next_i ;
int		sx0,sx1,sy0,sy1 ;
short	r,g,b,a ;
unsigned char	v ;
unsigned char	*uc_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	uc_buf = buf ;
	if( mode->vector == HORIZONTAL ){
		if( sy<0 ){
			sy0=0 ;
			i=(-sy)*3*width ;
		}else{
			sy0=sy ;
			i=0 ;
		}
		sy1=sy+height ;
		for( y=sy0 ; (y<sy1 && y<vg_pt->height) ; y++ ){
			next_i = i+width*3 ;
			if( sx<0 ){
				sx0=0 ;
				i+=(-sx)*3 ;
			}else{
				sx0=sx ;
			}
			sx1=width+sx ;
			for( x=sx0 ; x<sx1 ; x++ ){
				if( x>(vg_pt->width-1) ){
					i=next_i ;
					break ;
				}
				j=x+y*vg_pt->width ;
#include	"vg_put_rgb8_core.c"
			}
		}
	}else{
		if( sy<0 ){
			sy0=0 ;
			i=(-sy)*3*width ;
		}else{
			sy0=sy ;
			i=0 ;
		}
		sy1=sy+height ;
		for( x=sy0 ; (x<sy1 && x<vg_pt->width) ; x++ ){
			next_i = i+width*3 ;
			sx0=sx ;
			if( (width+sx0)>vg_pt->height ){
				sx1=(vg_pt->height-1) ;
				i+=((width+sx0) - vg_pt->height)*3 ;
			}else{
				sx1=sx0+width-1 ;
			}
			for( y=sx1 ; y>=sx0 ; y-- ){
				if( y<0 ){
					i=next_i ;
					break ;
				}
				j=x+y*vg_pt->width ;
#include	"vg_put_rgb8_core.c"
			}
		}
	}
}

/**********************************************************************/
void put_rgba_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
struct	PIX_STRUCT	*pix_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	pix_buf= buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		if( y<0 || y>(vg_pt->height-1) ){
			i += width ;
			continue ;
		}
		for( x=sx ; x<sx+width ; x++ ){
			if( x>=0 && x < vg_pt->width ){
				pix_pt[x+y*vg_pt->width] = pix_buf[i++] ;
			}else{
				i++ ;
			}
		}
	}
}

/**********************************************************************/
void put_rgb_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			pix_pt[x+y*vg_pt->width].r = us_buf[i++] / 256 ;
			pix_pt[x+y*vg_pt->width].g = us_buf[i++] / 256 ;
			pix_pt[x+y*vg_pt->width].b = us_buf[i++] / 256 ;
		}
	}
}

/**********************************************************************/
void put_rgba_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                    int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			pix_pt[x+y*vg_pt->width].r = us_buf[i++] / 256 ;
			pix_pt[x+y*vg_pt->width].g = us_buf[i++] / 256 ;
			pix_pt[x+y*vg_pt->width].b = us_buf[i++] / 256 ;
			pix_pt[x+y*vg_pt->width].a = us_buf[i++] / 256 ;
		}
	}
}

/**********************************************************************/
void put_gray_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
register short	x,y ;
register int	i,j ;
int		next_i ;
int		sx0,sx1,sy0,sy1 ;
short	a ;
unsigned char	v ;
unsigned char	*uc_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	uc_buf = buf ;
	if( mode->vector == HORIZONTAL ){
		if( sy<0 ){
			sy0=0 ;
			i=(-sy)*width ;
		}else{
			sy0=sy ;
			i=0 ;
		}
		sy1=sy+height ;
		for( y=sy0 ; (y<sy1 && y<vg_pt->height) ; y++ ){
			next_i = i+width ;
			if( sx<0 ){
				sx0=0 ;
				i+=(-sx) ;
			}else{
				sx0=sx ;
			}
			sx1=width+sx ;
			for( x=sx0 ; x<sx1 ; x++ ){
				if( x>(vg_pt->width-1) ){
					i=next_i ;
					break ;
				}
				j=x+y*vg_pt->width ;
#include	"vg_put_gry8_core.c"
				i++ ;
			}
		}
	}else{
		if( sy<0 ){
			sy0=0 ;
			i=(-sy)*width ;
		}else{
			sy0=sy ;
			i=0 ;
		}
		sy1=sy+height ;
		for( x=sy0 ; (x<sy1 && x<vg_pt->width) ; x++ ){
			next_i = i+width ;
			sx0=sx ;
			if( (width+sx0)>vg_pt->height ){
				sx1=(vg_pt->height-1) ;
				i+=((width+sx0) - vg_pt->height) ;
			}else{
				sx1=sx0+width-1 ;
			}
			for( y=sx1 ; y>=sx0 ; y-- ){
				if( y<0 ){
					i=next_i ;
					break ;
				}
				j=x+y*vg_pt->width ;
#include	"vg_put_gry8_core.c"
				i++ ;
			}
		}
	}
}

/**********************************************************************/
void put_gray_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                    int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			pix_pt[x+y*vg_pt->width].r = us_buf[i] / 256 ;
			pix_pt[x+y*vg_pt->width].g = us_buf[i] / 256 ;
			pix_pt[x+y*vg_pt->width].b = us_buf[i] / 256 ;
			i++ ;
		}
	}
}

/**********************************************************************/
void put_mask_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned char	*uc_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	uc_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		if( y<0 || y>(vg_pt->height-1) ){
			i += width ;
			continue ;
		}
		for( x=sx ; x<sx+width ; x++ ){
			if( x>=0 && x < vg_pt->width ){
				pix_pt[x+y*vg_pt->width].a = uc_buf[i] ;
			}
			i++ ;
		}
	}
}

/**********************************************************************/
void put_mask_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                    int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			pix_pt[x+y*vg_pt->width].a = us_buf[i++] / 256 ;
		}
	}
}


